'''
    This script splits the dataset in 4 datasets, each one
    will be a training set for each classifier of the model
'''

import csv

IN = 'unlabelled dataset (csv)'
OUT_OS = 'dataset objective - subjective (csv)'
OUT_PN = 'dataset positive - negative (csv)'
OUT_PE = 'dataset positive emotions (csv)'
OUT_NE = 'dataset negative emotions (csv)'

open(OUT_OS, 'w').close()
open(OUT_PN, 'w').close()
open(OUT_PE, 'w').close()
open(OUT_NE, 'w').close()

with open(IN, 'r') as inFile:


    # dataset objective - subjective
    reader = csv.reader(inFile, delimiter=';')
    next(reader) # skip header
    with open(OUT_OS, 'a') as out_os:
        writer_os = csv.writer(out_os, delimiter=';')
        writer_os.writerow(['label','post']) # write header
        for row in reader: # for each file line (after headers) 
            newRow = []
            newRow.append(row[0])
            newRow.append(row[3])
            writer_os.writerow(newRow) 
    print('dataset objective - subjective DONE')


    # dataset positive - negative
    inFile.seek(0) # move the cursor to the beginning of the file
    reader = csv.reader(inFile, delimiter=';')
    next(reader) # skip header
    with open(OUT_PN, 'a') as out_pn:
        writer_pn = csv.writer(out_pn, delimiter=';')
        writer_pn.writerow(['label','post']) # write header
        for row in reader: # for each file line (after headers) 
            newRow = []
            if row[0] != 'objective':
                newRow.append(row[1])
                newRow.append(row[3])
                writer_pn.writerow(newRow) 
    print('dataset positive - negative DONE')   


    # dataset positive emotions
    inFile.seek(0) # move the cursor to the beginning of the file
    reader = csv.reader(inFile, delimiter=';')
    next(reader) # skip header
    with open(OUT_PE, 'a') as out_pe:
        writer_pe = csv.writer(out_pe, delimiter=';')
        writer_pe.writerow(['label','post']) # write header
        for row in reader: # for each file line (after headers) 
            newRow = []
            if row[1] == 'positive':
                newRow.append(row[2].split(',')[0])
                newRow.append(row[3])
                writer_pe.writerow(newRow)   
    print('dataset positive emotions DONE')


    # dataset negative emotions
    inFile.seek(0) # move the cursor to the beginning of the file
    reader = csv.reader(inFile, delimiter=';')
    next(reader) # skip header
    with open(OUT_NE, 'a') as out_ne:
        writer_ne = csv.writer(out_ne, delimiter=';')
        writer_ne.writerow(['label','post']) # write header
        for row in reader: # for each file line (after headers) 
            newRow = []
            if row[1] == 'negative':
                newRow.append(row[2].split(',')[0])
                newRow.append(row[3])
                writer_ne.writerow(newRow)
    print('dataset negative emotions DONE')