'''
    This script takes a dataset made of type 1 and 2 posts and
    creates a new dataset with only type 1 posts that have at least
    a matching tag with top languages
'''

import csv

IN = ['first unfiltered dataset (csv)', 'second unfiltered dataset (csv)', '...']
OUT = ['first filtered dataset (csv)', 'second filtered dataset (csv)', '...']

LANGUAGES = ['javascript', 'html', 'css', 'sql', 'java', 'bash', 'shell', 'python', 'c#', 'php', 'c++', 'c', 'typescript', 'ruby', 'swift', 'assembly', 'go', 'objective-c', 'vb.net', 'r', 'matlab', 'vba', 'kotlin', 'scala', 'groovy', 'perl']

for inputFile, outputFile in zip(IN, OUT):
    count = 0
    open(outputFile, 'w').close()
    with open(inputFile, 'r') as inFile, open(outputFile, 'a') as outFile:
        reader = csv.reader(inFile, delimiter=';')
        next(reader) # skip header
        writer = csv.writer(outFile, delimiter=';')
        writer.writerow(['id', 'tags', 'date', 'title', 'post']) # write header
        for row in reader: # for each file line (after headers) 
            if row[1] != '':     
                for word in row[1].split(): # for each word in the 'tags' field (until found one)
                    if word in LANGUAGES: # check if that word is in 'LANGUAGES', stop at the first found
                        writer.writerow(row)
                        count+=1
                        break
                
    print('{0}\t{1}\n'.format(inputFile, count))