'''
This script balances the number of instances of each class
'''

import csv

# file paths
SOURCE = 'unbalanced dataset (csv)'
BALANCED = 'balanced dataset (csv)'

MAX = 5000 # maximum number of istances 

open(BALANCED, 'w').close() # clean output file

with open(SOURCE, 'r') as inFile, open(BALANCED, 'a') as outFile:
    reader = csv.reader(inFile, delimiter=';')
    next(reader) # skip header
    writer = csv.writer(outFile, delimiter=';')
    writer.writerow(['label','post'])

    # counters
    obj = 0
    subj = 0
    pos = 0
    neg = 0
    love = 0
    joy = 0
    surprise = 0
    anger = 0
    sadness = 0
    fear = 0

    for row in reader:
        if row[0] == 'objective' and obj < MAX:
            writer.writerow(row)
            obj += 1
        if row[0] == 'subjective' and subj < MAX:
            writer.writerow(row)
            subj += 1
        if row[0] == 'positive' and pos < MAX:
            writer.writerow(row)
            pos += 1
        if row[0] == 'negative' and neg < MAX:
            writer.writerow(row)
            neg += 1
        if row[0] == 'love' and love < MAX:
            writer.writerow(row)
            love += 1
        if row[0] == 'joy' and joy < MAX:
            writer.writerow(row)
            joy += 1
        if row[0] == 'surprise' and surprise < MAX:
            writer.writerow(row)
            surprise += 1
        if row[0] == 'anger' and anger < MAX:
            writer.writerow(row)
            anger += 1
        if row[0] == 'sadness' and sadness < MAX:
            writer.writerow(row)
            sadness += 1
        if row[0] == 'fear' and fear < MAX:
            writer.writerow(row)
            fear += 1
    
    print('obj = {0}\nsubj = {1}\npos = {2}\nneg = {3}\nlove = {4}\njoy = {5}\nsurprise = {6}\nanger = {7}\nsadness = {8}\nfear = {9}\n'.format(
        obj, subj, pos, neg, love, joy, surprise, anger, sadness, fear))
    
