import csv

POS = ['datasets labelled by the third classifier', '...']
NEG = ['datasets labelled by the fourth classifier', '...']
CSV = 'output csv file'

LANGUAGES = ['javascript', 'html', 'css', 'sql', 'java', 'bash', 'shell', 'python', 'c#', 'php', 'c++', 'c', 'typescript', 'ruby', 'swift', 'assembly', 'go', 'objective-c', 'vb.net', 'r', 'matlab', 'vba', 'kotlin', 'scala', 'groovy', 'perl']


open(CSV, mode='w').close()
with open(CSV, mode='a') as outFile:
    writer = csv.writer(outFile, delimiter=';')
    writer.writerow(['language', 'month', 'total', 'positive total','negative total',
    'joy', 'love', 'surprise', 'sad', 'fear', 'anger',
    'joy %', 'love %', 'surprise %', 'sad %', 'fear %', 'anger %'])
    
    for language in LANGUAGES:
        monthNumber = 0
        for pos, neg in zip(POS, NEG):
            newRow = []
            # absolute number of istances of each class
            joyCnt = loveCnt = surpriseCnt = angerCnt = fearCnt = sadCnt = 0

            with open(pos) as inFile:
                reader = csv.reader(inFile, delimiter=';')
                next(reader) # skip header row
                for row in reader:
                    for word in row[5].split(): # for each word in the 'tags' field
                        if word == language:
                            if row[0] == 'joy':
                                joyCnt+=1
                            elif row[0] == 'love':
                                loveCnt+=1
                            elif row[0] == 'surpris':
                                surpriseCnt+=1
                            break


            with open(neg) as inFile:
                reader = csv.reader(inFile, delimiter=';')
                next(reader) # skip header row
                for row in reader:
                    for word in row[5].split(): # for each word in the 'tags' field
                        if word == language:
                            if row[0] == 'sad':
                                sadCnt+=1
                            elif row[0] == 'fear':
                                fearCnt+=1
                            elif row[0] == 'anger':
                                angerCnt+=1
                            break

            posTotal = joyCnt + loveCnt + surpriseCnt
            negTotal =  sadCnt + fearCnt + angerCnt
            allTotal = posTotal + negTotal

            # % of istances of each class
            joyPct = lovePct = surprisePct = sadPct = fearPct = angerPct = 0
            if joyCnt != 0: 
                joyPct = joyCnt*100/allTotal

            if loveCnt != 0:
                lovePct = loveCnt*100/allTotal
            
            if surpriseCnt != 0:
                surprisePct = surpriseCnt*100/allTotal
            
            if sadCnt != 0:    
                sadPct = sadCnt*100/allTotal
            
            if fearCnt != 0:    
                fearPct = fearCnt*100/allTotal
            
            if angerCnt != 0:    
                angerPct = angerCnt*100/allTotal

            monthNumber += 1
            newRow.append(language)
            newRow.append(monthNumber)
            newRow.append(allTotal)
            newRow.append(posTotal)
            newRow.append(negTotal)
            newRow.append(joyCnt)
            newRow.append(loveCnt)
            newRow.append(surpriseCnt)
            newRow.append(sadCnt)
            newRow.append(fearCnt)
            newRow.append(angerCnt)
            newRow.append(joyPct)
            newRow.append(lovePct)
            newRow.append(surprisePct)
            newRow.append(sadPct)
            newRow.append(fearPct)
            newRow.append(angerPct)
            writer.writerow(newRow)
            print('DONE', language, monthNumber)


print('\n\tDONE')