import matplotlib.pyplot as plt
from matplotlib.patches import Patch
import numpy as np
import csv

LANGUAGES = ['javascript', 'html', 'css', 'sql', 'java', 'bash', 'shell', 'python', 'c#', 'php', 'c++', 'c', 'typescript', 'ruby', 'swift', 'assembly', 'go', 'objective-c', 'vb.net', 'r', 'matlab', 'vba', 'kotlin', 'scala', 'groovy', 'perl']

# get language from user, then get the index of that language
langIndex = LANGUAGES.index(input("Enter language\n"))

# x axis labels
labels = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec']

# values for each bar type
joy = []
love = []
surprise = []
sad = []
fear = []
anger = []

# populate lists with values
with open('prevoius csv file') as inFile:
    fileReader = csv.reader(inFile, delimiter=';')
    next(fileReader) # skip header row
    for row in fileReader:
        if row[0] == LANGUAGES[langIndex]:
            joy.append(float(row[11]))
            love.append(float(row[12]))
            surprise.append(float(row[13]))
            sad.append(float(row[14]))
            fear.append(float(row[15]))
            anger.append(float(row[16]))


xpos = np.arange(len(labels))
plt.xticks(xpos, labels)
plt.ylabel('%')
plt.title(LANGUAGES[langIndex])

plt.bar(xpos-0.05, surprise, width=0.1, label='Surprise', color='#753BBD') # purple
plt.bar(xpos+0.05, sad, width=0.1, label='Sad', color='#FF7F41') # orange
plt.bar(xpos-0.15, love, width=0.1, label='Love', color='#2DC84D') # green
plt.bar(xpos+0.15, fear, width=0.1, label='Fear', color='#F7EA48') # yellow
plt.bar(xpos-0.25, joy, width=0.1, label='Joy', color='#147BD1') # blue
plt.bar(xpos+0.25, anger, width=0.1, label='Anger', color='#E03C31') # red

legend_elements = [
    Patch(facecolor='#147BD1', label='joy'),
    Patch(facecolor='#2DC84D', label='love'),
    Patch(facecolor='#753BBD', label='surprise'),
    Patch(facecolor='#FF7F41', label='sad'),
    Patch(facecolor='#F7EA48', label='fear'),
    Patch(facecolor='#E03C31', label='anger')
    ]

plt.legend(handles=legend_elements, loc='best')
plt.show()
